/*
   CharData.h
   Declare an object with translated character data.

*/

#ifndef CharData_H
#define CharData_H

#include "CharCommon.h"

class CharData
{
public:
   //Initializing
   CharData();
   ~CharData();
   CharData* withCharExtent(int w, int h);
   CharData* withWordWidth(int w);
   CharData* withMapping(unsigned char* to, unsigned long* as, int sizeInWords, int sizeInBits);
   CharData* addPixelLine(png_byte* line);
   //Printing
   CharData* setStyle(const char* x);
   CharData* print(FILE* f);
   //Translating
   CharData* translate();
   //Accessing
protected:
   //char extent
   int charWidth;
   int charHeight;
   //word width in bits
   int wordWidth;
   //mapping
   unsigned char* mapTo;     //translated to word index
   unsigned long* mapAs;     //and mask
   int mapSizeInWords;       //how many words the map covers
   int mapSizeInBits;        //how many pixels the map covers
   //image
   char* image;
   int lines;
   //image translated to words
   unsigned long wordArray[MAX_WORDS_PER_CHAR];
   int words;
   //printing style (prefix before a hex number)
   const char* style;
};

#endif
